import 'package:flutter/material.dart';
import 'package:flutter_custom_toolbox/flutter_toolbox.dart';

import 'package:jeweled/cubit/game_cubit.dart';
import 'package:jeweled/models/game/game.dart';
import 'package:jeweled/ui/widgets/indicators/indicator_available_blocks.dart';
import 'package:jeweled/ui/widgets/indicators/indicator_moves_count.dart';
import 'package:jeweled/ui/widgets/indicators/indicator_score.dart';
import 'package:jeweled/ui/widgets/indicators/indicator_shuffle_button.dart';

class GameTopWidget extends StatelessWidget {
  const GameTopWidget({super.key});

  @override
  Widget build(BuildContext context) {
    return BlocBuilder<GameCubit, GameState>(
      builder: (BuildContext context, GameState gameState) {
        final Game currentGame = gameState.currentGame;

        return Column(
          children: [
            ScoreIndicator(game: currentGame),
            Table(
              defaultVerticalAlignment: TableCellVerticalAlignment.middle,
              children: [
                TableRow(
                  children: [
                    Center(
                      child: MovesCountsIndicator(game: currentGame),
                    ),
                    AvailableBlocksCountIndicator(game: currentGame),
                    Center(
                      child: ShuffleButton(game: currentGame),
                    ),
                  ],
                )
              ],
            ),
          ],
        );
      },
    );
  }
}
